   PROGRAM

   MAP
      Main
      InputBox(STRING InputStr),STRING
      Include('winapi.inc','Prototypes')
   END
   INCLUDE('ftp.def')
   INCLUDE('KeyCodes.clw')

   Code
   Main

Main     PROCEDURE

DirList     DirectoryListQueueType

LocalFile   STRING(MAX_PATH)
Server      STRING(255)
Proxy       STRING(255)
User        STRING(128)
Pasword     STRING(128)
StatusTxt   STRING(255)
NewName     STRING(MAX_PATH)

FTPClient   FTP

Window WINDOW('Ftp'),AT(,,276,203),FONT('Tahoma',8,,FONT:regular),ICON(ICON:Application),TIMER(50),SYSTEM, |
         GRAY,MAX,RESIZE
       PROMPT('Server :'),AT(4,11),USE(?ServerPrompt)
       ENTRY(@s255),AT(44,10,125,10),USE(Server)
       PROMPT('User :'),AT(4,26),USE(?UserPrompt)
       ENTRY(@s32),AT(44,25,125,10),USE(User)
       PROMPT('Password :'),AT(4,41),USE(?PaswordPrompt)
       ENTRY(@s32),AT(44,40,125,10),USE(Pasword),PASSWORD
       PROMPT('Proxy :'),AT(4,56),USE(?ProxyPrompt)
       ENTRY(@s64),AT(44,55,125,10),USE(Proxy)
       PROMPT('&Local File :'),AT(4,71),USE(?LocalFilePrompt)
       ENTRY(@s20),AT(44,70,125,10),USE(LocalFile)
       BUTTON('&Connect'),AT(178,8,45,14),USE(?Connect)
       BUTTON('&Disconnect'),AT(228,8,45,14),USE(?Disconnect)
       BUTTON('Do&wnload'),AT(178,28,45,14),USE(?Download)
       BUTTON('&Upload'),AT(228,28,45,14),USE(?Upload)
       BUTTON('&Remove'),AT(178,48,45,14),USE(?Remove)
       BUTTON('R&ename'),AT(228,48,45,14),USE(?Rename)
       BUTTON('Create Directory'),AT(178,68,96,14),USE(?CreateDir)
       LIST,AT(2,86,271,102),USE(?List),HVSCROLL,ALRT(EnterKey),ALRT(MouseLeft2),FORMAT('169L(2)|M~Directory~@s255@20D(2)~Size~C(0)@n15B@'), |
           FROM(DirList)
       STRING(@s20),AT(2,192),USE(StatusTxt)
     END

      CODE
      Open(Window)
      ACCEPT
         CASE EVENT()
         OF EVENT:AlertKey
            CASE KeyCode()
            OF EnterKey
            OROF MouseLeft2
               GET(DirList,CHOICE(?List))
               IF Field() = ?List And Records(DirList) and BAND(DirList.Attributes,FILE_ATTRIBUTE_DIRECTORY)
                  FTPClient.ChangeDirectory(CLIP(DirList.Name))
                  FTPClient.GetDirectoryList(DirList)
               END
            END
         OF EVENT:CloseWindow
            IF FTPClient.IsConnected() then POST(EVENT:Accepted,?Disconnect).
         OF EVENT:Timer
            IF FTPClient.IsSession()
               Enable(?Disconnect,?CreateDir)
               IF Len(CLIP(LocalFile))
                  Enable(?Download)
                  IF EXISTS(CLIP(LocalFile))
                     Enable(?Upload)
                  ELSE
                     Disable(?Upload)
                  END
               ELSE
                  Disable(?Download)
                  Disable(?Upload)
               END
               Enable(?Disconnect)
            ELSE
               Disable(?Disconnect,?CreateDir)
            END
         OF EVENT:NewSelection
            IF FIELD() = ?List
               GET(DirList,CHOICE(?List))
               IF ~ERRORCODE()
                  StatusTxt = ''
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_DIRECTORY)
                     StatusTxt = 'Directory'
                  end
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_READONLY)
                     StatusTxt = CLIP(StatusTxt)&' '&'ReadOnly'
                  END
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_HIDDEN)
                     StatusTxt = CLIP(StatusTxt)&' '&'Hidden'
                  END
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_SYSTEM)
                     StatusTxt = CLIP(StatusTxt)&' '&'System'
                  END
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_ARCHIVE)
                     StatusTxt = CLIP(StatusTxt)&' '&'Archive'
                  END
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_ENCRYPTED)
                      StatusTxt = CLIP(StatusTxt)&' '&'Encrypted'
                  END
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_NORMAL)
                     StatusTxt = CLIP(StatusTxt)&' '&'Normal'
                  END
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_TEMPORARY)
                     StatusTxt = CLIP(StatusTxt)&' '&'Temporary'
                  END
                  IF BAND(DirList.Attributes,FILE_ATTRIBUTE_COMPRESSED)
                     StatusTxt = CLIP(StatusTxt)&' '&'Compressed'
                  END
               END
            END
         OF EVENT:Accepted
            CASE FIELD()
            OF ?Connect
               SetCursor(Cursor:Wait)
               IF ~FTPClient.IsSession() then FTPClient.Init(Server) .
               FTPClient.ShowErrors(TRUE)
               IF CLIP(User) <> '' AND CLIP(Pasword) <> '' then FTPClient.SetServerUser(CLIP(User),CLIP(Pasword)) .
               FTPClient.Connect()
               FTPClient.GetDirectoryList(DirList)
               SetCursor(Cursor:Arrow)
            OF ?Download
               SetCursor(Cursor:Wait)
               IF Len(LocalFile)
                  FTPClient.Download(CLIP(DirList.Name),LocalFile)
                  FTPClient.GetDirectoryList(DirList)
               END
               SetCursor(Cursor:Arrow)
            OF ?Upload
               IF Len(LocalFile)
                  NewName = InputBox('')
                  IF CLIP(NewName) <> ''
                     SetCursor(Cursor:Wait)
                     FTPClient.Upload(CLIP(LocalFile),CLIP(NewName))
                     FTPClient.GetDirectoryList(DirList)
                     SetCursor(Cursor:Arrow)
                  END
               END
            OF ?Disconnect
               FTPClient.Disconnect(TRUE)
               FREE(DirList)
            OF ?Remove
               Dir# = FALSE
               IF BAND(DirList.Attributes,FILE_ATTRIBUTE_DIRECTORY)
                  Dir# = TRUE
               ELSE
                  Dir# = FALSE
               END
               CASE Message('Do you wish to remove '&CLIP(DirList.Name)&'?','Warning !',,BUTTON:Yes+BUTTON:No,BUTTON:No)
               OF BUTTON:Yes
                  SetCursor(Cursor:Wait)
                  IF Dir#
                     FTPClient.RemoveDirectory(CLIP(DirList.Name))
                  ELSE
                     FTPClient.RemoveFile(CLIP(DirList.Name))
                  END
                  FTPClient.GetDirectoryList(DirList)
                  SetCursor(Cursor:Arrow)
               END
            OF ?Rename
               NewName = InputBox(CLIP(DirList.Name))
               IF CLIP(NewName) <> ''
                  SetCursor(Cursor:Wait)
                  FTPClient.RenameFile(CLIP(DirList.Name),CLIP(NewName))
                  FTPClient.GetDirectoryList(DirList)
                  SetCursor(Cursor:Arrow)
               END
            OF ?CreateDir
               NewName = InputBox(CLIP(DirList.Name))
               IF CLIP(NewName) <> ''
                  SetCursor(Cursor:Wait)
                  FTPClient.CreateDirectory(CLIP(NewName))
                  FTPClient.GetDirectoryList(DirList)
                  SetCursor(Cursor:Arrow)
               END
            END
         END
      END

InputBox    PROCEDURE(STRING InputStr)
NewName     STRING(MAX_PATH)
Window WINDOW('Input Name'),AT(,,234,46),FONT('Tahoma',8,,FONT:regular),CENTER,GRAY,DOUBLE,MODAL
       PROMPT('&Name :'),AT(6,6),USE(?NewNamePrompt)
       ENTRY(@s255),AT(52,5,178,10),USE(NewName)
       BUTTON('&OK'),AT(65,25,45,14),USE(?OK),DEFAULT
       BUTTON('&Cancel'),AT(123,25,45,14),USE(?Cancel),KEY(EscKey)
     END
   CODE
   NewName = InputStr
   OPEN(WINDOW)
   ACCEPT
      CASE EVENT()
      OF EVENT:CloseWindow
         RETURN('')
      OF EVENT:Accepted
         CASE FIELD()
         OF ?OK
            RETURN (CLIP(NewName))
         OF ?Cancel
            POST(Event:CloseWindow)
         END
      END
   END